require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ENDIAN_H_)) {
    eval 'sub _MACHINE_ENDIAN_H_ () {1;}' unless defined(&_MACHINE_ENDIAN_H_);
    require 'sys/cdefs.ph';
    require 'sys/_types.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub _QUAD_HIGHWORD () {1;}' unless defined(&_QUAD_HIGHWORD);
    eval 'sub _QUAD_LOWWORD () {0;}' unless defined(&_QUAD_LOWWORD);
    eval 'sub _LITTLE_ENDIAN () {1234;}' unless defined(&_LITTLE_ENDIAN);
    eval 'sub _BIG_ENDIAN () {4321;}' unless defined(&_BIG_ENDIAN);
    eval 'sub _PDP_ENDIAN () {3412;}' unless defined(&_PDP_ENDIAN);
    eval 'sub _BYTE_ORDER () { &_LITTLE_ENDIAN;}' unless defined(&_BYTE_ORDER);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub LITTLE_ENDIAN () { &_LITTLE_ENDIAN;}' unless defined(&LITTLE_ENDIAN);
	eval 'sub BIG_ENDIAN () { &_BIG_ENDIAN;}' unless defined(&BIG_ENDIAN);
	eval 'sub PDP_ENDIAN () { &_PDP_ENDIAN;}' unless defined(&PDP_ENDIAN);
	eval 'sub BYTE_ORDER () { &_BYTE_ORDER;}' unless defined(&BYTE_ORDER);
    }
    if(defined(&__GNUCLIKE_ASM)  && defined(&__GNUCLIKE_BUILTIN_CONSTANT_P)) {
	eval 'sub __bswap64_const {
	    my($_x) = @_;
    	    eval q(((($_x) >> 56) | ((($_x) >> 40) & (0xff << 8)) | ((($_x) >> 24) & (0xff << 16)) | ((($_x) >> 8) & (0xff << 24)) | ((($_x) << 8) & (0xff << 32)) | ((($_x) << 24) & (0xff << 40)) | ((($_x) << 40) & (0xff << 48)) | (($_x) << 56)));
	}' unless defined(&__bswap64_const);
	eval 'sub __bswap32_const {
	    my($_x) = @_;
    	    eval q(((($_x) >> 24) | ((($_x) & (0xff << 16)) >> 8) | ((($_x) & (0xff << 8)) << 8) | (($_x) << 24)));
	}' unless defined(&__bswap32_const);
	eval 'sub __bswap16_const {
	    my($_x) = @_;
    	    eval q(( &__uint16_t)(($_x) << 8| ($_x) >> 8));
	}' unless defined(&__bswap16_const);
	eval 'sub __bswap64_var {
	    my($__x) = @_;
    	    eval q({  &__bswap64_const($__x); });
	}' unless defined(&__bswap64_var);
	eval 'sub __bswap32_var {
	    my($_x) = @_;
    	    eval q({  &__asm (\\"bswap %0\\" : \\"+r\\" ($_x)); ($_x); });
	}' unless defined(&__bswap32_var);
	eval 'sub __bswap16_var {
	    my($_x) = @_;
    	    eval q({ ( &__bswap16_const($_x)); });
	}' unless defined(&__bswap16_var);
	eval 'sub __bswap64 {
	    my($_x) = @_;
    	    eval q(( &__builtin_constant_p($_x) ?  &__bswap64_const(( &__uint64_t)($_x)) :  &__bswap64_var($_x)));
	}' unless defined(&__bswap64);
	eval 'sub __bswap32 {
	    my($_x) = @_;
    	    eval q(( &__builtin_constant_p($_x) ?  &__bswap32_const(( &__uint32_t)($_x)) :  &__bswap32_var($_x)));
	}' unless defined(&__bswap32);
	eval 'sub __bswap16 {
	    my($_x) = @_;
    	    eval q((( &__uint16_t)( &__builtin_constant_p($_x) ?  &__bswap16_const(( &__uint16_t)($_x)) :  &__bswap16_var($_x))));
	}' unless defined(&__bswap16);
	eval 'sub __htonl {
	    my($x) = @_;
    	    eval q( &__bswap32($x));
	}' unless defined(&__htonl);
	eval 'sub __htons {
	    my($x) = @_;
    	    eval q( &__bswap16($x));
	}' unless defined(&__htons);
	eval 'sub __ntohl {
	    my($x) = @_;
    	    eval q( &__bswap32($x));
	}' unless defined(&__ntohl);
	eval 'sub __ntohs {
	    my($x) = @_;
    	    eval q( &__bswap16($x));
	}' unless defined(&__ntohs);
    } else {
	eval 'sub _BYTEORDER_FUNC_DEFINED () {1;}' unless defined(&_BYTEORDER_FUNC_DEFINED);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
