require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_REG_H_)) {
    eval 'sub _MACHINE_REG_H_ () {1;}' unless defined(&_MACHINE_REG_H_);
    eval 'sub tFS () {(0);}' unless defined(&tFS);
    eval 'sub tES () {(1);}' unless defined(&tES);
    eval 'sub tDS () {(2);}' unless defined(&tDS);
    eval 'sub tEDI () {(3);}' unless defined(&tEDI);
    eval 'sub tESI () {(4);}' unless defined(&tESI);
    eval 'sub tEBP () {(5);}' unless defined(&tEBP);
    eval 'sub tISP () {(6);}' unless defined(&tISP);
    eval 'sub tEBX () {(7);}' unless defined(&tEBX);
    eval 'sub tEDX () {(8);}' unless defined(&tEDX);
    eval 'sub tECX () {(9);}' unless defined(&tECX);
    eval 'sub tEAX () {(10);}' unless defined(&tEAX);
    eval 'sub tERR () {(12);}' unless defined(&tERR);
    eval 'sub tEIP () {(13);}' unless defined(&tEIP);
    eval 'sub tCS () {(14);}' unless defined(&tCS);
    eval 'sub tEFLAGS () {(15);}' unless defined(&tEFLAGS);
    eval 'sub tESP () {(16);}' unless defined(&tESP);
    eval 'sub tSS () {(17);}' unless defined(&tSS);
    eval 'sub tGS () {(18);}' unless defined(&tGS);
    eval 'sub DBREG_DR7_LOCAL_ENABLE () {0x1;}' unless defined(&DBREG_DR7_LOCAL_ENABLE);
    eval 'sub DBREG_DR7_GLOBAL_ENABLE () {0x2;}' unless defined(&DBREG_DR7_GLOBAL_ENABLE);
    eval 'sub DBREG_DR7_LEN_1 () {0x;}' unless defined(&DBREG_DR7_LEN_1);
    eval 'sub DBREG_DR7_LEN_2 () {0x1;}' unless defined(&DBREG_DR7_LEN_2);
    eval 'sub DBREG_DR7_LEN_4 () {0x3;}' unless defined(&DBREG_DR7_LEN_4);
    eval 'sub DBREG_DR7_EXEC () {0x;}' unless defined(&DBREG_DR7_EXEC);
    eval 'sub DBREG_DR7_WRONLY () {0x1;}' unless defined(&DBREG_DR7_WRONLY);
    eval 'sub DBREG_DR7_RDWR () {0x3;}' unless defined(&DBREG_DR7_RDWR);
    eval 'sub DBREG_DR7_MASK {
        my($i) = @_;
	    eval q((0xf << (($i) * 4+ 16) | 0x3 << ($i) * 2));
    }' unless defined(&DBREG_DR7_MASK);
    eval 'sub DBREG_DR7_SET {
        my($i, $len, $access, $enable) = @_;
	    eval q(((($len) << 2| ($access)) << (($i) * 4+ 16) | ($enable) << ($i) * 2));
    }' unless defined(&DBREG_DR7_SET);
    eval 'sub DBREG_DR7_GD () {0x2000;}' unless defined(&DBREG_DR7_GD);
    eval 'sub DBREG_DR7_ENABLED {
        my($d, $i) = @_;
	    eval q(((($d) & 0x3 << ($i) * 2) != 0));
    }' unless defined(&DBREG_DR7_ENABLED);
    eval 'sub DBREG_DR7_ACCESS {
        my($d, $i) = @_;
	    eval q((($d) >> (($i) * 4+ 16) & 0x3));
    }' unless defined(&DBREG_DR7_ACCESS);
    eval 'sub DBREG_DR7_LEN {
        my($d, $i) = @_;
	    eval q((($d) >> (($i) * 4+ 18) & 0x3));
    }' unless defined(&DBREG_DR7_LEN);
    eval 'sub DBREG_DRX {
        my($d,$x) = @_;
	    eval q((($d)-> $dr[($x)]));
    }' unless defined(&DBREG_DRX);
    if(defined(&_KERNEL)) {
    }
}
1;
