require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_BUFOBJ_H_)) {
    eval 'sub _SYS_BUFOBJ_H_ () {1;}' unless defined(&_SYS_BUFOBJ_H_);
    if(defined(&_KERNEL) || defined(&_KVM_VNODE)) {
	require 'sys/queue.ph';
	require 'sys/_lock.ph';
	require 'sys/_mutex.ph';
	eval 'sub BO_STRATEGY {
	    my($bo, $bp) = @_;
    	    eval q((($bo)-> ($bo_ops->{bop_strategy})(($bo), ($bp))));
	}' unless defined(&BO_STRATEGY);
	eval 'sub BO_SYNC {
	    my($bo, $w) = @_;
    	    eval q((($bo)-> ($bo_ops->{bop_sync})(($bo), ($w))));
	}' unless defined(&BO_SYNC);
	eval 'sub BO_WRITE {
	    my($bo, $bp) = @_;
    	    eval q((($bo)-> ($bo_ops->{bop_write})(($bp))));
	}' unless defined(&BO_WRITE);
	eval 'sub BO_BDFLUSH {
	    my($bo, $bp) = @_;
    	    eval q((($bo)-> ($bo_ops->{bop_bdflush})(($bo), ($bp))));
	}' unless defined(&BO_BDFLUSH);
	eval 'sub BO_ONWORKLST () {(1<< 0);}' unless defined(&BO_ONWORKLST);
	eval 'sub BO_WWAIT () {(1<< 1);}' unless defined(&BO_WWAIT);
	eval 'sub BO_NEEDSGIANT () {(1<< 2);}' unless defined(&BO_NEEDSGIANT);
	eval 'sub BO_MTX {
	    my($bo) = @_;
    	    eval q((($bo)-> &bo_mtx));
	}' unless defined(&BO_MTX);
	eval 'sub BO_LOCK {
	    my($bo) = @_;
    	    eval q( &mtx_lock( &BO_MTX(($bo))));
	}' unless defined(&BO_LOCK);
	eval 'sub BO_UNLOCK {
	    my($bo) = @_;
    	    eval q( &mtx_unlock( &BO_MTX(($bo))));
	}' unless defined(&BO_UNLOCK);
	eval 'sub ASSERT_BO_LOCKED {
	    my($bo) = @_;
    	    eval q( &mtx_assert( &BO_MTX(($bo)),  &MA_OWNED));
	}' unless defined(&ASSERT_BO_LOCKED);
	eval 'sub ASSERT_BO_UNLOCKED {
	    my($bo) = @_;
    	    eval q( &mtx_assert( &BO_MTX(($bo)),  &MA_NOTOWNED));
	}' unless defined(&ASSERT_BO_UNLOCKED);
    }
}
1;
