require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_VMPARAM_H_)) {
    eval 'sub _MACHINE_VMPARAM_H_ () {1;}' unless defined(&_MACHINE_VMPARAM_H_);
    eval 'sub MAXTSIZ () {(128*1024*1024);}' unless defined(&MAXTSIZ);
    unless(defined(&DFLDSIZ)) {
	eval 'sub DFLDSIZ () {(128*1024*1024);}' unless defined(&DFLDSIZ);
    }
    unless(defined(&MAXDSIZ)) {
	eval 'sub MAXDSIZ () {(512*1024*1024);}' unless defined(&MAXDSIZ);
    }
    unless(defined(&DFLSSIZ)) {
	eval 'sub DFLSSIZ () {(8*1024*1024);}' unless defined(&DFLSSIZ);
    }
    unless(defined(&MAXSSIZ)) {
	eval 'sub MAXSSIZ () {(64*1024*1024);}' unless defined(&MAXSSIZ);
    }
    unless(defined(&SGROWSIZ)) {
	eval 'sub SGROWSIZ () {(128*1024);}' unless defined(&SGROWSIZ);
    }
    eval 'sub VM_PHYSSEG_DENSE () {1;}' unless defined(&VM_PHYSSEG_DENSE);
    eval 'sub VM_PHYSSEG_MAX () {17;}' unless defined(&VM_PHYSSEG_MAX);
    eval 'sub VM_NFREEPOOL () {2;}' unless defined(&VM_NFREEPOOL);
    eval 'sub VM_FREEPOOL_CACHE () {1;}' unless defined(&VM_FREEPOOL_CACHE);
    eval 'sub VM_FREEPOOL_DEFAULT () {0;}' unless defined(&VM_FREEPOOL_DEFAULT);
    eval 'sub VM_FREEPOOL_DIRECT () {0;}' unless defined(&VM_FREEPOOL_DIRECT);
    eval 'sub VM_NFREELIST () {2;}' unless defined(&VM_NFREELIST);
    eval 'sub VM_FREELIST_DEFAULT () {0;}' unless defined(&VM_FREELIST_DEFAULT);
    eval 'sub VM_FREELIST_ISADMA () {1;}' unless defined(&VM_FREELIST_ISADMA);
    if(defined(&PAE)) {
	eval 'sub VM_NFREEORDER () {10;}' unless defined(&VM_NFREEORDER);
    } else {
	eval 'sub VM_NFREEORDER () {11;}' unless defined(&VM_NFREEORDER);
    }
    unless(defined(&VM_NDOMAIN)) {
	eval 'sub VM_NDOMAIN () {1;}' unless defined(&VM_NDOMAIN);
    }
    unless(defined(&VM_NRESERVLEVEL)) {
	eval 'sub VM_NRESERVLEVEL () {1;}' unless defined(&VM_NRESERVLEVEL);
    }
    unless(defined(&VM_LEVEL_0_ORDER)) {
	if(defined(&PAE)) {
	    eval 'sub VM_LEVEL_0_ORDER () {9;}' unless defined(&VM_LEVEL_0_ORDER);
	} else {
	    eval 'sub VM_LEVEL_0_ORDER () {10;}' unless defined(&VM_LEVEL_0_ORDER);
	}
    }
    unless(defined(&KERNLOAD)) {
	if(defined(&XEN)  && !defined(&XEN_PRIVILEGED_GUEST)) {
	    eval 'sub KERNLOAD () {0;}' unless defined(&KERNLOAD);
	} else {
	    eval 'sub KERNLOAD () {(1<<  &PDRSHIFT);}' unless defined(&KERNLOAD);
	}
    }
    if(defined(&XEN)) {
	eval 'sub VM_MAX_KERNEL_ADDRESS () { &HYPERVISOR_VIRT_START;}' unless defined(&VM_MAX_KERNEL_ADDRESS);
    } else {
	eval 'sub VM_MAX_KERNEL_ADDRESS () { &VADDR( &KPTDI+ &NKPDE-1,  &NPTEPG-1);}' unless defined(&VM_MAX_KERNEL_ADDRESS);
    }
    eval 'sub VM_MIN_KERNEL_ADDRESS () { &VADDR( &PTDPTDI,  &PTDPTDI);}' unless defined(&VM_MIN_KERNEL_ADDRESS);
    eval 'sub KERNBASE () { &VADDR( &KPTDI, 0);}' unless defined(&KERNBASE);
    eval 'sub UPT_MAX_ADDRESS () { &VADDR( &PTDPTDI,  &PTDPTDI);}' unless defined(&UPT_MAX_ADDRESS);
    eval 'sub UPT_MIN_ADDRESS () { &VADDR( &PTDPTDI, 0);}' unless defined(&UPT_MIN_ADDRESS);
    eval 'sub VM_MAXUSER_ADDRESS () { &VADDR( &PTDPTDI, 0);}' unless defined(&VM_MAXUSER_ADDRESS);
    eval 'sub SHAREDPAGE () {( &VM_MAXUSER_ADDRESS -  &PAGE_SIZE);}' unless defined(&SHAREDPAGE);
    eval 'sub USRSTACK () { &SHAREDPAGE;}' unless defined(&USRSTACK);
    eval 'sub VM_MAX_ADDRESS () { &VADDR( &PTDPTDI,  &PTDPTDI);}' unless defined(&VM_MAX_ADDRESS);
    eval 'sub VM_MIN_ADDRESS () {(( &vm_offset_t)0);}' unless defined(&VM_MIN_ADDRESS);
    unless(defined(&VM_KMEM_SIZE)) {
	eval 'sub VM_KMEM_SIZE () {(12* 1024* 1024);}' unless defined(&VM_KMEM_SIZE);
    }
    unless(defined(&VM_KMEM_SIZE_SCALE)) {
	eval 'sub VM_KMEM_SIZE_SCALE () {(3);}' unless defined(&VM_KMEM_SIZE_SCALE);
    }
    unless(defined(&VM_KMEM_SIZE_MAX)) {
	eval 'sub VM_KMEM_SIZE_MAX () {((((( &VM_MAX_KERNEL_ADDRESS -  &VM_MIN_KERNEL_ADDRESS) >> ( &PDRSHIFT - 2)) + 5) / 10) <<  &PDRSHIFT);}' unless defined(&VM_KMEM_SIZE_MAX);
    }
    unless(defined(&VM_INITIAL_PAGEIN)) {
	eval 'sub VM_INITIAL_PAGEIN () {16;}' unless defined(&VM_INITIAL_PAGEIN);
    }
    eval 'sub ZERO_REGION_SIZE () {(64* 1024);}' unless defined(&ZERO_REGION_SIZE);
}
1;
