require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__pkinit_asn1_h__)) {
    eval 'sub __pkinit_asn1_h__ () {1;}' unless defined(&__pkinit_asn1_h__);
    require 'stddef.ph';
    require 'time.ph';
    unless(defined(&__asn1_common_definitions__)) {
	eval 'sub __asn1_common_definitions__ () {1;}' unless defined(&__asn1_common_definitions__);
	eval 'sub ASN1_MALLOC_ENCODE {
	    my($T, $B, $BL, $S, $L, $R) = @_;
    	    eval q( &do { ($BL) =  &length_$T(($S)); ($B) =  &malloc(($BL));  &if(($B) ==  &NULL) { ($R) =  &ENOMEM; }  &else { ($R) =  &encode_$T((($B)) + ($BL) - 1, ($BL), ($S), ($L));  &if(($R) != 0) {  &free(($B)); ($B) =  &NULL; } } }  &while (0));
	}' unless defined(&ASN1_MALLOC_ENCODE);
    }
    require 'krb5_asn1.ph';
    require 'cms_asn1.ph';
    require 'rfc2459_asn1.ph';
    require 'heim_asn1.ph';
    eval("sub pa_pk_as_req () { 16; }") unless defined(&pa_pk_as_req);
    eval("sub pa_pk_as_rep () { 17; }") unless defined(&pa_pk_as_rep);
    eval("sub td_trusted_certifiers () { 104; }") unless defined(&td_trusted_certifiers);
    eval("sub td_invalid_certificates () { 105; }") unless defined(&td_invalid_certificates);
    eval("sub td_dh_parameters () { 109; }") unless defined(&td_dh_parameters);
    eval("sub choice_PA_PK_AS_REP_asn1_ellipsis () { 0; }") unless defined(&choice_PA_PK_AS_REP_asn1_ellipsis);
    eval("sub choice_PA_PK_AS_REP_dhInfo () { 1; }") unless defined(&choice_PA_PK_AS_REP_dhInfo);
    eval("sub choice_PA_PK_AS_REP_encKeyPack () { 2; }") unless defined(&choice_PA_PK_AS_REP_encKeyPack);
    eval("sub choice_TrustedCA_Win2k_caName () { 1; }") unless defined(&choice_TrustedCA_Win2k_caName);
    eval("sub choice_TrustedCA_Win2k_issuerAndSerial () { 2; }") unless defined(&choice_TrustedCA_Win2k_issuerAndSerial);
    eval("sub choice_PA_PK_AS_REP_Win2k_dhSignedData () { 1; }") unless defined(&choice_PA_PK_AS_REP_Win2k_dhSignedData);
    eval("sub choice_PA_PK_AS_REP_Win2k_encKeyPack () { 2; }") unless defined(&choice_PA_PK_AS_REP_Win2k_encKeyPack);
}
1;
