require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__rfc2459_asn1_h__)) {
    eval 'sub __rfc2459_asn1_h__ () {1;}' unless defined(&__rfc2459_asn1_h__);
    require 'stddef.ph';
    require 'time.ph';
    unless(defined(&__asn1_common_definitions__)) {
	eval 'sub __asn1_common_definitions__ () {1;}' unless defined(&__asn1_common_definitions__);
	eval 'sub ASN1_MALLOC_ENCODE {
	    my($T, $B, $BL, $S, $L, $R) = @_;
    	    eval q( &do { ($BL) =  &length_$T(($S)); ($B) =  &malloc(($BL));  &if(($B) ==  &NULL) { ($R) =  &ENOMEM; }  &else { ($R) =  &encode_$T((($B)) + ($BL) - 1, ($BL), ($S), ($L));  &if(($R) != 0) {  &free(($B)); ($B) =  &NULL; } } }  &while (0));
	}' unless defined(&ASN1_MALLOC_ENCODE);
    }
    require 'heim_asn1.ph';
    eval("sub rfc3280_version_1 () { 0; }") unless defined(&rfc3280_version_1);
    eval("sub rfc3280_version_2 () { 1; }") unless defined(&rfc3280_version_2);
    eval("sub rfc3280_version_3 () { 2; }") unless defined(&rfc3280_version_3);
    eval("sub choice_DirectoryString_ia5String () { 1; }") unless defined(&choice_DirectoryString_ia5String);
    eval("sub choice_DirectoryString_teletexString () { 2; }") unless defined(&choice_DirectoryString_teletexString);
    eval("sub choice_DirectoryString_printableString () { 3; }") unless defined(&choice_DirectoryString_printableString);
    eval("sub choice_DirectoryString_universalString () { 4; }") unless defined(&choice_DirectoryString_universalString);
    eval("sub choice_DirectoryString_utf8String () { 5; }") unless defined(&choice_DirectoryString_utf8String);
    eval("sub choice_DirectoryString_bmpString () { 6; }") unless defined(&choice_DirectoryString_bmpString);
    eval("sub choice_Name_rdnSequence () { 1; }") unless defined(&choice_Name_rdnSequence);
    eval("sub choice_Time_utcTime () { 1; }") unless defined(&choice_Time_utcTime);
    eval("sub choice_Time_generalTime () { 2; }") unless defined(&choice_Time_generalTime);
    eval("sub choice_GeneralName_otherName () { 1; }") unless defined(&choice_GeneralName_otherName);
    eval("sub choice_GeneralName_rfc822Name () { 2; }") unless defined(&choice_GeneralName_rfc822Name);
    eval("sub choice_GeneralName_dNSName () { 3; }") unless defined(&choice_GeneralName_dNSName);
    eval("sub choice_GeneralName_directoryName () { 4; }") unless defined(&choice_GeneralName_directoryName);
    eval("sub choice_GeneralName_uniformResourceIdentifier () { 5; }") unless defined(&choice_GeneralName_uniformResourceIdentifier);
    eval("sub choice_GeneralName_iPAddress () { 6; }") unless defined(&choice_GeneralName_iPAddress);
    eval("sub choice_GeneralName_registeredID () { 7; }") unless defined(&choice_GeneralName_registeredID);
    eval("sub choice_GeneralName_directoryName_rdnSequence () { 1; }") unless defined(&choice_GeneralName_directoryName_rdnSequence);
    if(defined(&__PARSE_UNITS_H__)) {
    }
    if(defined(&__PARSE_UNITS_H__)) {
    }
    eval("sub choice_DistributionPointName_fullName () { 1; }") unless defined(&choice_DistributionPointName_fullName);
    eval("sub choice_DistributionPointName_nameRelativeToCRLIssuer () { 2; }") unless defined(&choice_DistributionPointName_nameRelativeToCRLIssuer);
    eval("sub unspecified () { 0; }") unless defined(&unspecified);
    eval("sub keyCompromise () { 1; }") unless defined(&keyCompromise);
    eval("sub cACompromise () { 2; }") unless defined(&cACompromise);
    eval("sub affiliationChanged () { 3; }") unless defined(&affiliationChanged);
    eval("sub superseded () { 4; }") unless defined(&superseded);
    eval("sub cessationOfOperation () { 5; }") unless defined(&cessationOfOperation);
    eval("sub certificateHold () { 6; }") unless defined(&certificateHold);
    eval("sub removeFromCRL () { 8; }") unless defined(&removeFromCRL);
    eval("sub privilegeWithdrawn () { 9; }") unless defined(&privilegeWithdrawn);
    eval("sub aACompromise () { 10; }") unless defined(&aACompromise);
}
1;
