require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__ROKEN_H__)) {
    eval 'sub __ROKEN_H__ () {1;}' unless defined(&__ROKEN_H__);
    require 'stdio.ph';
    require 'stdlib.ph';
    require 'stdarg.ph';
    require 'stdint.ph';
    require 'string.ph';
    require 'signal.ph';
    require 'sys/param.ph';
    require 'inttypes.ph';
    require 'sys/types.ph';
    require 'unistd.ph';
    require 'sys/socket.ph';
    require 'sys/uio.ph';
    require 'grp.ph';
    require 'sys/stat.ph';
    require 'netinet/in.ph';
    require 'arpa/inet.ph';
    require 'netdb.ph';
    require 'arpa/nameser.ph';
    require 'resolv.ph';
    require 'syslog.ph';
    require 'fcntl.ph';
    require 'errno.ph';
    require 'err.ph';
    require 'termios.ph';
    require 'sys/ioctl.ph';
    require 'sys/time.ph';
    require 'time.ph';
    require 'strings.ph';
    require 'paths.ph';
    require 'roken-common.ph';
    eval 'sub rk_UNCONST {
        my($x) = @_;
	    eval q((( &void *)( &uintptr_t)( &const  &void *)($x)));
    }' unless defined(&rk_UNCONST);
    require 'pwd.ph';
    eval 'sub roken_getservbyname {
        my($x,$y) = @_;
	    eval q( &getservbyname($x,$y));
    }' unless defined(&roken_getservbyname);
    eval 'sub roken_openlog {
        my($a,$b,$c) = @_;
	    eval q( &openlog($a,$b,$c));
    }' unless defined(&roken_openlog);
    eval 'sub roken_getsockname {
        my($a,$b,$c) = @_;
	    eval q( &getsockname($a,$b,$c));
    }' unless defined(&roken_getsockname);
    eval 'sub ROKEN_VERSION () {1.1;}' unless defined(&ROKEN_VERSION);
}
1;
